CodeForces 185A Plant 矩阵快速幂

题意:最开始给你一个正三角形,每一步,一个正三角形可以变成三个正三角形和一个反三角形,而一个反三角形可以构成一个正三角形和三个反三角形,问额你n步之后一共有多少个正三角形。

解题思路:因为n太大,有10^18这么大,所以我们只能用矩阵快速幂来求。

中间矩阵为

3 1

1 3

初始矩阵为

0 (负)

1 (正)

解题代码:

 1 // File Name: temp.cpp
 2 // Author: darkdream
 3 // Created Time: 2014年09月17日 星期三 11时35分45秒
 4
 5 #include<vector>
 6 #include<list>
 7 #include<map>
 8 #include<set>
 9 #include<deque>
10 #include<stack>
11 #include<bitset>
12 #include<algorithm>
13 #include<functional>
14 #include<numeric>
15 #include<utility>
16 #include<sstream>
17 #include<iostream>
18 #include<iomanip>
19 #include<cstdio>
20 #include<cmath>
21 #include<cstdlib>
22 #include<cstring>
23 #include<ctime>
24 #define LL long long
25 #define m 1000000007
26 using namespace std;
27 int n ;
28 struct Matrix
29 {
30    LL mat[20][20];
31    void clear()
32    {
33       memset(mat,0,sizeof(mat));
34    }
35    void output()
36    {
37      for(int i =0  ;i < n ;i ++)
38      {
39        for(int j = 0 ;j < n ;j ++)
40            printf("%I64d ",mat[i][j]);
41      printf("\n");
42      }
43    }
44    void init()
45    {
46        n = 2;
47        clear();
48        mat[0][0] = 3;
49        mat[0][1] = 1;
50        mat[1][0] = 1;
51        mat[1][1] = 3;
52    }
53    Matrix operator *(const Matrix &b) const
54    {
55        Matrix ret;
56        ret.clear();
57        for(int i = 0 ;i < n ;i ++)
58            for(int j = 0;j < n;j ++)
59            {
60                for(int k = 0 ;k < n ;k ++)
61                {
62                  ret.mat[i][j] =(ret.mat[i][j] + mat[i][k] * b.mat[k][j]) % m ; // 第I 行  第J  列
63                }
64            }
65        return ret;
66    }
67 };
68 Matrix Pow( Matrix a ,LL t )
69 {
70   Matrix ret;
71   ret.clear();
72   for(int i = 0 ;i < n ;i ++)
73        ret.mat[i][i] = 1;
74   Matrix tmp = a;
75   while(t)
76   {
77       if(t&1) ret = ret * tmp;
78       tmp = tmp * tmp;
79       t >>=1;
80   }
81   return ret;
82 }
83 int main(){
84     LL l ;
85     while(scanf("%I64d",&l) != EOF)
86     {
87         if(l == 0)
88         {
89           printf("1\n");
90           continue;
91         }
92         Matrix  a;
93         a.init();
94         a = Pow(a,l);
95         printf("%I64d\n",a.mat[1][1]);
96     }
97     return 0;
98 }

时间: 2024-12-25 18:00:01

CodeForces 185A Plant 矩阵快速幂的相关文章

Codeforces - 185A 简单矩阵快速幂

题意:求第n个三角形内部的上三角形个数 对每个三角形分别维护上下三角形个数,记为\(dp[1][i],dp[2][i]\) 规律很明显是 \(dp[1][i+1]=3*dp[1][i]+dp[2][i]\) \(dp[2][i+1]=3*dp[2][i]+dp[1][i]\) 别忘了快速幂里也要long long,白送了个TLE /*H E A D*/ inline ll mod(ll a){return a%MOD;} struct Matrix{ ll mt[5][5],r,c; void

CodeForces 450B (矩阵快速幂模板题+负数取模)

题目链接:http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=51919 题目大意:斐波那契数列推导.给定前f1,f2,推出指定第N项.注意负数取模的方式:-1%(10^9+7)=10^9+6. 解题思路: 首先解出快速幂矩阵.以f3为例. [f2]  * [1 -1] = [f2-f1]=[f3]  (幂1次) [f1]  * [1  0]     [f2]      [f2] 于是fn=[f2] *[1 -1]^(n-2)

Plant 矩阵快速幂,,,,有点忘了

题目链接:https://codeforces.com/contest/185/problem/A 题目大意就是求n次以后  方向朝上的三角形的个数 以前写过这个题,但是忘了怎么做的了,,,又退了一遍,发现第n次后  总个数为2^n+(2^n+!)/2个,,但是部分数据过不去,可能是卡long long 把,然后看了其他人写的. 规律  每一次分解 朝上的三角形可以分解为 新的3个朝上的三角形和一个朝下的三角形,朝下的三角形可以分解为3个朝下的新三角形和一个朝上的三角形 所以  b(n)=3*b

CodeForces 185A. Plant(矩阵快速幂)

题目链接:http://codeforces.com/problemset/problem/185/A Dwarfs have planted a very interesting plant, which is a triangle directed "upwards". This plant has an amusing feature. After one year a triangle plant directed "upwards" divides int

codeforces 185a(矩阵快速幂)

题意:三角形变化过程如下图 问正着的三角形的个数,n=1时1个,n=2时3个,n=3时10 - . 题解:可以找到规律 正x 倒y 1 0 3 1 10 6 - - 3*x+y 3*y+x 然后构造矩阵用矩阵快速幂求解. #include <cstdio> #include <iostream> #include <cstring> using namespace std; const int MOD = 1000000007; const int N = 3; str

【矩阵快速幂 】Codeforces 450B - Jzzhu and Sequences (公式转化)

[题目链接]click here~~ [题目大意] Jzzhu has invented a kind of sequences, they meet the following property: You are given x and y, please calculate fn modulo1000000007(109?+?7). [解题思路] /*A - Jzzhu and Sequences Codeforces 450B - Jzzhu and Sequences ( 矩阵快速幂 )

Codeforces Round #257 (Div. 2) B. Jzzhu and Sequences (矩阵快速幂)

题目链接:http://codeforces.com/problemset/problem/450/B 题意很好懂,矩阵快速幂模版题. 1 /* 2 | 1, -1 | | fn | 3 | 1, 0 | | fn-1 | 4 */ 5 #include <iostream> 6 #include <cstdio> 7 #include <cstring> 8 using namespace std; 9 typedef __int64 LL; 10 LL mod =

Xor-sequences CodeForces - 691E || 矩阵快速幂

Xor-sequences CodeForces - 691E 题意:在有n个数的数列中选k个数(可以重复选,可以不按顺序)形成一个数列,使得任意相邻两个数异或的结果转换成二进制后其中1的个数是三的倍数.求可能形成的不同数列个数(只要选出的数列中,任意两个元素在原序列中的位置不同,就算作不同的序列,比如在原数列[1,1]中选1个,那么第一个1和第二个1要分开算). 方法: 很容易列出dp方程: dp[k][i]表示取了k个,最后一个在第i位.a[i][j]表示i和j异或结果转换成二进制后1的个数

[递推+矩阵快速幂]Codeforces 1117D - Magic Gems

传送门:Educational Codeforces Round 60 – D 题意: 给定N,M(n <1e18,m <= 100) 一个magic gem可以分裂成M个普通的gem,现在需要N个gem,可以选择一定的magic gem,指定每一个分裂或不分裂,问一共有多少种方案 两种分裂方案不同当且仅当magic gem的数量不同,或者分裂的magic gem的索引不同. 思路: 1.首先从dp的角度出发 设F(i)为最终需要i个gem的方案数,容易得到递推式: (总方案数 = 最右边的m